/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.im.runtime.jbpm.comboprovider;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.stp.im.runtime.IAnnotationDependentComboProviderValues;
import org.eclipse.stp.im.runtime.comboproviders.ComboEntries;

public class ExtractSubProcessVariableComboProvider implements IAnnotationDependentComboProviderValues  {
	
	protected  EAnnotation ea = null;
	private static final String NO_VARIABLE_DEFINED_BY_SUBPROCESS = "-- No Variable Defined In Subprocess --";
	
	public ComboEntries getComboEntries() {
		
		ComboEntries subProcessVariableValues =  new ComboEntries();
		String[] variables = null;
		//TODO: This code was using metadb and should not in spagic3
		/*
		try{
			//String subProcessVariables = "Sotto 1";
			final String subprocessName = ea.getDetails().get("SubProcess");
			
			List<Property> variableList = (List<Property>)MetaDBHelper.doExecuteNoTx(new IMetaDBCommand(){
				public Object execute(Session aSession) throws Throwable {
					String lastVersion =  AuditDBUtils.getCurrentProcessVersion(subprocessName, aSession);
//					System.out.println(" Last Version For ["+subprocessName+"]= " + lastVersion);
					org.spagic.metadb.model.Process p = AuditDBUtils.getProcessByNameAndVersion(aSession, subprocessName, lastVersion);
					return AuditDBUtils.getProcessPropertyWithNameLike(aSession, p, "Var[" );
				}
			});
		
		
			if (variableList.size() > 0){
				variables = new String[variableList.size()];
				int i=0;
				for (Property var : variableList) {
					variables[i] = stripVariableName(var.getCode());
					i++;
				}
			}else{
				variables = new String[1];
				variables[0] = NO_VARIABLE_DEFINED_BY_SUBPROCESS;
			}
		
		}catch (Throwable t) {
			
			t.printStackTrace();
			variables = new String[1];
			variables[0] = NO_VARIABLE_DEFINED_BY_SUBPROCESS;
			
		}
		
		subProcessVariableValues.setLabels(variables);
		subProcessVariableValues.setValues(variables);
		
		return subProcessVariableValues;
		*/
		
		variables = new String[1];
		variables[0] = NO_VARIABLE_DEFINED_BY_SUBPROCESS;
		subProcessVariableValues.setLabels(variables);
		subProcessVariableValues.setValues(variables);
		
		return subProcessVariableValues;
	}

	public void setAnnotation(EAnnotation ea) {
		this.ea = ea;
		
	}
	
	public String stripVariableName(String varName) {
		String realVarName = varName.substring(varName.indexOf("[")+1, varName.indexOf("]"));
		return realVarName;
	}
	
	
	


}
