/**

    Copyright 2007, 2009 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.bpel.externalserviceextension.ui.factories;

import org.spagic3.bpel.externalserviceextension.model.ModelPackage;
import org.spagic3.bpel.externalserviceextension.ui.Activator;
import org.spagic3.bpel.externalserviceextension.ui.ExternalServiceExtensionUIConstants;
import org.eclipse.bpel.ui.factories.AbstractUIObjectFactory;
import org.eclipse.bpel.ui.factories.IExtensionUIObjectFactory;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;

public class ExternalServiceExtensionUIObjectFactory extends AbstractUIObjectFactory implements
IExtensionUIObjectFactory{
	
	private EClass modelType;
	private EClass[] classArray = { ModelPackage.eINSTANCE.getExternalServiceActivity()};

	public ExternalServiceExtensionUIObjectFactory(EClass modelType) {
		super();
		this.modelType = modelType;
	}
	
	public ExternalServiceExtensionUIObjectFactory() {
		super();
	}
	
	public Image getLargeImage() {
		return Activator.getDefault().getImageRegistry().get(ExternalServiceExtensionUIConstants.EXTERNAL_SERVICE_ICON_32);
	}

	public ImageDescriptor getLargeImageDescriptor() {
		return Activator.getDefault().getImageDescriptor(ExternalServiceExtensionUIConstants.EXTERNAL_SERVICE_ICON_32);
	}

	public EClass getModelType() {
		return this.modelType;
	}

	public Image getSmallImage() {
		return Activator.getDefault().getImageRegistry().get(ExternalServiceExtensionUIConstants.EXTERNAL_SERVICE_ICON_16);
	}

	public ImageDescriptor getSmallImageDescriptor() {
		return Activator.getDefault().getImageDescriptor(ExternalServiceExtensionUIConstants.EXTERNAL_SERVICE_ICON_16);
	}

	public String getTypeLabel() {
		return getModelType().getName();
	}

	public EClass[] getClassArray() {
		return this.classArray;
	}

	public void setModelType(EClass modelType) {
		this.modelType = modelType;
	}

}
