/**

    Copyright 2007, 2009 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.bpel.externalserviceextension.ui.palette;

import java.util.Iterator;
import java.util.List;

import org.eclipse.bpel.common.ui.palette.IPaletteProvider;
import org.eclipse.bpel.common.ui.palette.PaletteCategory;
import org.eclipse.bpel.ui.util.BPELCreationToolEntry;
import org.eclipse.gef.palette.PaletteRoot;
import org.spagic3.bpel.externalserviceextension.model.ModelPackage;
import org.spagic3.bpel.externalserviceextension.ui.factories.ExternalServiceExtensionUIObjectFactory;

public class ExternalServiceExtensionPaletteProvider implements IPaletteProvider {
	public void contributeItems(PaletteRoot paletteRoot) {
		PaletteCategory spagicPaletteCategory = getSpagicCategory(paletteRoot);
		spagicPaletteCategory
				.add(new BPELCreationToolEntry("External Service Activity", "External Service Activity",
						new ExternalServiceExtensionUIObjectFactory(ModelPackage.eINSTANCE
								.getExternalServiceActivity())));
	
	}
	
	private PaletteCategory getSpagicCategory(PaletteRoot paletteRoot){
		List paletteContainerList = paletteRoot.getChildren();
		Iterator it = paletteContainerList.iterator();
		while (it.hasNext()){
			Object obj = it.next();
			if (obj instanceof PaletteCategory){
				PaletteCategory paletteCategory = (PaletteCategory)obj;
				if(paletteCategory.getLabel().equalsIgnoreCase("Spagic")){
					return paletteCategory;
				}
			}
		}
		PaletteCategory spagicPaletteCategory = new PaletteCategory("Spagic");
		spagicPaletteCategory.setCategoryId("bpel.spagic");
		spagicPaletteCategory.setOrder(40);
		paletteRoot.add(spagicPaletteCategory);
		return spagicPaletteCategory;
	}
}
