/**

    Copyright 2007, 2009 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.bpel.manualactivitiesextension.model.util;

import java.util.Map;

import javax.wsdl.extensions.ExtensionRegistry;
import javax.xml.namespace.QName;

import org.eclipse.bpel.model.Activity;
import org.eclipse.bpel.model.Process;
import org.eclipse.bpel.model.extensions.BPELActivityDeserializer;
import org.eclipse.bpel.model.resource.BPELReader;
import org.eclipse.emf.common.util.URI;
import org.spagic3.bpel.manualactivitiesextension.model.ManualActivity;
import org.spagic3.bpel.manualactivitiesextension.model.ModelFactory;
import org.spagic3.bpel.manualactivitiesextension.model.ModelPackage;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class ManualActivityDeserializer implements
		BPELActivityDeserializer{
	public Activity unmarshall(QName elementType, Node node, Process process,
			Map nsMap, ExtensionRegistry extReg, URI uri, BPELReader bpelReader) {
		if (ManualActivityExtensionConstants.ND_MANUAL_ACTIVITY.equals(elementType
				.getLocalPart())) {

			Element manualActivityElement = (Element) node;

			// create a new ExternalServiceActivity model object
			ManualActivity manualActivity = ModelFactory.eINSTANCE
					.createManualActivity();

			// attach the DOM node to our new activity
			manualActivity.setElement(manualActivityElement);
			
			// handle the activity and input attributes
			String attName = ModelPackage.eINSTANCE
					.getManualActivity_ActivityName().getName();
			if (((Element) node).getAttribute(attName) != null) {
				manualActivity.setActivityName(((Element) node)
						.getAttribute("activityName"));
			}
			
			attName = ModelPackage.eINSTANCE
				.getManualActivity_Input().getName();
			if (((Element) node).getAttribute(attName) != null) {
				manualActivity.setInput(((Element) node)
						.getAttribute("input"));
			}
			
			return manualActivity;
		}
		return null;
	}

}

