/**

    Copyright 2007, 2009 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.bpel.relevantdataextension.model.util;

import java.util.Map;

import javax.wsdl.extensions.ExtensionRegistry;
import javax.xml.namespace.QName;

import org.eclipse.bpel.model.Activity;
import org.eclipse.bpel.model.Process;
import org.eclipse.bpel.model.extensions.BPELActivityDeserializer;
import org.eclipse.bpel.model.resource.BPELReader;
import org.eclipse.emf.common.util.URI;
import org.spagic3.bpel.relevantdataextension.model.ModelFactory;
import org.spagic3.bpel.relevantdataextension.model.ModelPackage;
import org.spagic3.bpel.relevantdataextension.model.RelevantDataActivity;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class RelevantDataActivityDeserializer implements
		BPELActivityDeserializer {

	public Activity unmarshall(QName elementType, Node node, Process process,
			Map nsMap, ExtensionRegistry extReg, URI uri, BPELReader bpelReader) {
		if (RelevantDataExtensionConstants.ND_EXTERNAL_SERVICE_ACTIVITY.equals(elementType
				.getLocalPart())) {

			Element externalServiceActivityElement = (Element) node;

			// create a new ExternalServiceActivity model object
			RelevantDataActivity relevantDataActivity = ModelFactory.eINSTANCE
					.createRelevantDataActivity();

			// attach the DOM node to our new activity
			relevantDataActivity.setElement(externalServiceActivityElement);
			
			String attName = ModelPackage.eINSTANCE
					.getRelevantDataActivity_Variable().getName();
			if (((Element) node).getAttribute(attName) != null) {
				relevantDataActivity.setVariable(((Element) node)
						.getAttribute("variable"));
			}
			
			attName = ModelPackage.eINSTANCE
			.getRelevantDataActivity_Xpath().getName();
			if (((Element) node).getAttribute(attName) != null) {
				relevantDataActivity.setXpath(((Element) node)
						.getAttribute("xpath"));
			}	
			attName = ModelPackage.eINSTANCE
			.getRelevantDataActivity_AttributeName().getName();
			if (((Element) node).getAttribute(attName) != null) {
				relevantDataActivity.setAttributeName(((Element) node)
						.getAttribute("attributeName"));
			}

			return relevantDataActivity;
		}
		return null;
	}

}
