package org.spagic3.bpel.relevantdataextension.ui.factories;

import org.eclipse.bpel.ui.factories.AbstractUIObjectFactory;
import org.eclipse.bpel.ui.factories.IExtensionUIObjectFactory;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;
import org.spagic3.bpel.relevantdataextension.model.ModelPackage;
import org.spagic3.bpel.relevantdataextension.ui.Activator;
import org.spagic3.bpel.relevantdataextension.ui.RelevantDataExtensionUIConstants;

public class RelevantDataUIObjectFactory extends AbstractUIObjectFactory 
	implements IExtensionUIObjectFactory{

	private EClass modelType;
	private EClass[] classArray = { ModelPackage.eINSTANCE.getRelevantDataActivity()};

	public RelevantDataUIObjectFactory(EClass modelType) {
		super();
		this.modelType = modelType;
	}
	
	public RelevantDataUIObjectFactory() {
		super();
	}
	
	@Override
	public Image getLargeImage() {
		return Activator.getDefault().getImageRegistry().get(RelevantDataExtensionUIConstants.RELEVANT_DATA_ACTIVITY_ICON_32);
	}

	@Override
	public ImageDescriptor getLargeImageDescriptor() {
		return Activator.getDefault().getImageDescriptor(RelevantDataExtensionUIConstants.RELEVANT_DATA_ACTIVITY_ICON_32);
	}

	@Override
	public EClass getModelType() {
		return this.modelType;
	}

	@Override
	public Image getSmallImage() {
		return Activator.getDefault().getImageRegistry().get(RelevantDataExtensionUIConstants.RELEVANT_DATA_ACTIVITY_ICON_16);
	}

	@Override
	public ImageDescriptor getSmallImageDescriptor() {
		return Activator.getDefault().getImageDescriptor(RelevantDataExtensionUIConstants.RELEVANT_DATA_ACTIVITY_ICON_16);
	}

	@Override
	public String getTypeLabel() {
		return getModelType().getName();
	}

	public EClass[] getClassArray() {
		return this.classArray;
	}

	public void setModelType(EClass modelType) {
		this.modelType = modelType;
	}
}