package org.spagic3.bpel.relevantdataextension.ui.palette;

import java.util.Iterator;
import java.util.List;

import org.eclipse.bpel.common.ui.palette.IPaletteProvider;
import org.eclipse.bpel.common.ui.palette.PaletteCategory;
import org.eclipse.bpel.ui.util.BPELCreationToolEntry;
import org.eclipse.gef.palette.PaletteRoot;
import org.spagic3.bpel.relevantdataextension.model.ModelPackage;
import org.spagic3.bpel.relevantdataextension.ui.factories.RelevantDataUIObjectFactory;

public class RelevantDataPaletteProvider implements IPaletteProvider {
	public void contributeItems(PaletteRoot paletteRoot) {
		PaletteCategory spagicPaletteCategory = getSpagicCategory(paletteRoot);
		spagicPaletteCategory
				.add(new BPELCreationToolEntry("Relevant Data", "Relevant Data",
						new RelevantDataUIObjectFactory(ModelPackage.eINSTANCE
								.getRelevantDataActivity())));
	
		
	}
	
	private PaletteCategory getSpagicCategory(PaletteRoot paletteRoot){
		List paletteContainerList = paletteRoot.getChildren();
		Iterator it = paletteContainerList.iterator();
		while (it.hasNext()){
			Object obj = it.next();
			if (obj instanceof PaletteCategory){
				PaletteCategory paletteCategory = (PaletteCategory)obj;
				if(paletteCategory.getLabel().equalsIgnoreCase("Spagic")){
					return paletteCategory;
				}
			}
		}
		PaletteCategory spagicPaletteCategory = new PaletteCategory("Spagic");
		spagicPaletteCategory.setCategoryId("bpel.spagic");
		spagicPaletteCategory.setOrder(40);
		paletteRoot.add(spagicPaletteCategory);
		return spagicPaletteCategory;
	}
}

