/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.im.out.jbpm;

import java.io.InputStream;
import java.net.URL;

import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.runtime.resource.loader.ClasspathResourceLoader;
import org.osgi.framework.Bundle;
import org.spagic3.utils.SpagicLogger;

public class BundleResourceLoader extends ClasspathResourceLoader {

	 public synchronized InputStream getResourceStream(String name)  throws ResourceNotFoundException {
		 try{
			 if ((name == null) || (name.length() == 0)) {
				 throw new ResourceNotFoundException("TemplateName Is Not Valid");
			 }

			 if (name.startsWith("/")) {
				 throw new ResourceNotFoundException("TemplateName Must Not Start With slash character ");
			 }
    
			 Bundle bundle =  Im2JbpmActivator.getDefault().getBundle();
			 if (bundle != null) {
				 URL resource =  bundle.getResource(name);
				 if (resource != null){
					 return resource.openStream();
				 }
			 }
			 return null;
		 }catch (Exception e) {
			 SpagicLogger.error(Im2JbpmActivator.PLUGIN_ID, e.getMessage(), e);
			 return null;
		 }
		 
	 }

}
