package org.spagic3.im.out.jbpm.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import org.eclipse.stp.im.constants.*;
import org.eclipse.emf.common.util.EMap;
import java.util.*;
import org.spagic3.utils.*;
import org.spagic3.im.out.jbpm.utils.*;

public class _jet_transitions implements JET2Template {

    public _jet_transitions() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        //
        //
        //    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.
        //
        //    This file is part of Spagic.
        //
        //    Spagic is free software; you can redistribute it and/or modify
        //    it under the terms of the GNU Lesser General Public License as published by
        //    the Free Software Foundation; either version 3 of the License, or
        //    any later version.
        //
        //    Spagic is distributed in the hope that it will be useful,
        //    but WITHOUT ANY WARRANTY; without even the implied warranty of
        //    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        //    GNU Lesser General Public License for more details.
        //
        //    You should have received a copy of the GNU Lesser General Public License
        //    along with this program.  If not, see <http://www.gnu.org/licenses/>.
        //    
        out.write("\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         

	//System.out.println(" TransitionsJET ");
	org.eclipse.stp.im.Step currentStep = (org.eclipse.stp.im.Step)(context.getVariable("currentStep"));
	
	
	List<Transition> transitionInGenerationOrder = new ArrayList<Transition>();
	
	// Aggiungo prima le transizioni che non hanno condizioni
	for ( Transition aTransition : currentStep.getSourceTransitions()){
		BasicProperty bp = (BasicProperty) aTransition.getProperties().get("Expression");
		
		if (bp == null){
			transitionInGenerationOrder.add(aTransition);
		}
	}
	
	// Poi metto tutte le transizioni condizionate
	for ( Transition aTransition : currentStep.getSourceTransitions()){
		BasicProperty bp = (BasicProperty) aTransition.getProperties().get("Expression");
		
		if (bp != null){
			transitionInGenerationOrder.add(aTransition);
		}
	}
	
	for ( Transition aTransition : transitionInGenerationOrder){
		BasicProperty bp = (BasicProperty) aTransition.getProperties().get("Expression");
		
		String transitionName = aTransition.getSource().getName() + "to"+aTransition.getTarget().getName();
		if (bp != null){
			String elExpression = bp.getValue();

        out.write("\t\t\t<transition name=\"");  //$NON-NLS-1$        
        out.write(transitionName);
        out.write("\" to=\"");  //$NON-NLS-1$        
        out.write(aTransition.getTarget().getName());
        out.write("\">");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t\t<condition expression=\"");  //$NON-NLS-1$        
        out.write(elExpression);
        out.write("\"></condition>");  //$NON-NLS-1$        
        out.write(NL);         
        out.write("\t\t\t</transition>");  //$NON-NLS-1$        
        out.write(NL);         

		}else{

        out.write("\t\t\t<transition name=\"");  //$NON-NLS-1$        
        out.write(transitionName);
        out.write("\" to=\"");  //$NON-NLS-1$        
        out.write(aTransition.getTarget().getName());
        out.write("\"/>");  //$NON-NLS-1$        
        out.write(NL);         

		}

	}

        out.write(NL);         
        out.write(NL);         
        out.write(NL);         
        out.write(NL);         
    }
}
