package org.spagic3.im.out.jbpm.compiled;

import org.eclipse.jet.JET2Context;
import org.eclipse.jet.JET2Template;
import org.eclipse.jet.JET2Writer;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.ecore.resource.*;
import org.eclipse.stp.im.*;
import org.eclipse.stp.im.impl.*;
import org.eclipse.stp.im.constants.*;
import org.eclipse.emf.common.util.EMap;
import java.util.*;
import org.spagic3.utils.*;
import org.spagic3.im.out.jbpm.utils.*;

public class _jet_varmap implements JET2Template {

    public _jet_varmap() {
        super();
    }

    private static final String NL = System.getProperty("line.separator"); //$NON-NLS-1$

    public void generate(final JET2Context context, final JET2Writer __out) {
        JET2Writer out = __out;
        //
        //
        //    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.
        //
        //    This file is part of Spagic.
        //
        //    Spagic is free software; you can redistribute it and/or modify
        //    it under the terms of the GNU Lesser General Public License as published by
        //    the Free Software Foundation; either version 3 of the License, or
        //    any later version.
        //
        //    Spagic is distributed in the hope that it will be useful,
        //    but WITHOUT ANY WARRANTY; without even the implied warranty of
        //    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        //    GNU Lesser General Public License for more details.
        //
        //    You should have received a copy of the GNU Lesser General Public License
        //    along with this program.  If not, see <http://www.gnu.org/licenses/>.
        //    
        out.write("\t\t\t\t");  //$NON-NLS-1$        
        out.write(NL);         

	//System.out.println(" VarMapping ");
	org.eclipse.stp.im.Step currentStep = (org.eclipse.stp.im.Step)(context.getVariable("currentStep"));
	
	
	String mappedSubProcessVariableName = JBPMJetUtils.getOptionalPropertyValue(currentStep,"MappedSubProcessVariableName",null);
	String mappedInMainProcessVariableName = JBPMJetUtils.getOptionalPropertyValue(currentStep,"MappedInMainProcessVariableName",null);
	
	if ((mappedInMainProcessVariableName!= null) && (mappedSubProcessVariableName != null)){

        out.write("\t\t<variable access=\"read,write\" name=\"");  //$NON-NLS-1$        
        out.write(mappedInMainProcessVariableName);
        out.write("\" mapped-name=\"");  //$NON-NLS-1$        
        out.write(mappedSubProcessVariableName);
        out.write("\"></variable>");  //$NON-NLS-1$        
        out.write(NL);         

	}
	
	
	Map<String, String> varMappings = JBPMJetUtils.getMapVariable(currentStep,"VariablesMapping", "MainProcessVariable", "SubprocessVariable");
	for (String str : varMappings.keySet()){
		String value = varMappings.get(str);

        out.write("\t\t<variable access=\"read,write\" name=\"");  //$NON-NLS-1$        
        out.write(str);
        out.write("\" mapped-name=\"");  //$NON-NLS-1$        
        out.write(value);
        out.write("\"></variable>");  //$NON-NLS-1$        
        out.write(NL);         
	
	}

        out.write("\t");  //$NON-NLS-1$        
        out.write(NL);         
        out.write(NL);         
        out.write(NL);         
        out.write(NL);         
        out.write(NL);         
        out.write(NL);         
    }
}
