/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.ui.deploymentservice.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PlatformUI;
import org.spagic3.ui.deploymentservice.wizards.ServiceDeploymentWizard;

public class LaunchDeploymentWizard implements IWorkbenchWindowActionDelegate, IObjectActionDelegate {

//	private IWorkbenchPart targetPart;
	private ISelection selection;
	private boolean showProjectList = false;
	
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
//		this.targetPart = targetPart;
	}

	public void run(IAction action) {
		ServiceDeploymentWizard wizard = new ServiceDeploymentWizard(showProjectList);
		wizard.init(PlatformUI.getWorkbench(),
				selection instanceof IStructuredSelection
						? (IStructuredSelection) selection 
						: StructuredSelection.EMPTY);
		WizardDialog dialog = new WizardDialog(
				PlatformUI.getWorkbench()
						.getActiveWorkbenchWindow().getShell(), 
				wizard);
		dialog.open();
	}

	public void selectionChanged(IAction action, ISelection selection) {
		this.selection = selection;
	}

	public void dispose() {
	}

	public void init(IWorkbenchWindow window) {
		showProjectList = true;
		this.selection = window.getSelectionService().getSelection();
	}

}
