/**

    Copyright 2007, 2008, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
 **/
package org.spagic3.ui.embed.webapp.preference;

import org.eclipse.jface.preference.DirectoryFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Group;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.spagic3.utils.SpagicUtilsActivator;
import org.spagic3.utils.preference.SpagicPreferenceConstants;

public class EmbedSpagicSourcePreferencePage extends FieldEditorPreferencePage implements
IWorkbenchPreferencePage{

	private DirectoryFieldEditor serviceManagerDirEditor;
	private DirectoryFieldEditor embeddingDirEditor;
	
	public EmbedSpagicSourcePreferencePage() {
		super(GRID);
		setDescription("Embed Spagic Preferences");
		setPreferenceStore(SpagicUtilsActivator.getDefault().getPreferenceStore());
	}


	@Override
	protected void createFieldEditors() {
		Group serviceDeployPropertiesGroup = new Group(
				getFieldEditorParent(), 
				SWT.SHADOW_ETCHED_IN);
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		serviceDeployPropertiesGroup.setLayoutData(gd);
		serviceDeployPropertiesGroup.setText(" Embedding Spagic in a Webapp Section ");

		serviceManagerDirEditor = new DirectoryFieldEditor(
				SpagicPreferenceConstants.P_EMBEDDED_SERVICE_MANAGER_SOURCE_DIR, 
				"Service Manager Path", 
				serviceDeployPropertiesGroup);
		addField(serviceManagerDirEditor);

		embeddingDirEditor = new DirectoryFieldEditor(
				SpagicPreferenceConstants.P_EXTRA_EMBEDDING_FILES_SOURCE_DIR, 
				"Spagic Embedded Path", 
				serviceDeployPropertiesGroup);
		addField(embeddingDirEditor);

	}

	public void init(IWorkbench arg0) {
		// TODO Auto-generated method stub
		
	}

}
