/**

    Copyright 2007, 2008, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
 **/
package org.spagic3.ui.embed.webapp.utils
;

/**
 * Result from ProcessChecker. Thread Unsafe.
 *
 *
 * Created: Tue Jan  5 11:07:05 2010
 *
 * @author <a href="mailto:saint@eng.it">Gian Uberto Lauri</a>
 * @version $Revision$
 */
public class ProcessCheckerResult {

	private StringBuilder replyBuffer;
	private boolean allRight;
	
	ProcessCheckerResult() {
		replyBuffer = new StringBuilder();
		allRight = true;
	}

	void clean() {
		replyBuffer.delete(0, replyBuffer.length());
	}
	
	void addClaim(String claim) 
	{
		allRight = false;
		replyBuffer.append(claim);
		replyBuffer.append("\n ");
	}
	
	void setAllRightIfNoClaim() 
	{
		if (allRight) {
			replyBuffer.append("OK");
		}
	}
	
	public boolean isAllRight() {
		return allRight;
	}
	
	public String getReply() {
		return replyBuffer.toString();	
	}
	
}
