/**

    Copyright 2007, 2008, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
 **/
package org.spagic3.ui.embed.webapp.utils;

import java.io.PrintWriter;

public class WebXmlUtils {

	private final static String FILE_HEAD =
		"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" +
		"<web-app xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns=\"http://java.sun.com/xml/ns/javaee\" xmlns:web=\"http://java.sun.com/xml/ns/javaee/web-app_2_5.xsd\" xsi:schemaLocation=\"http://java.sun.com/xml/ns/javaee http://java.sun.com/xml/ns/javaee/web-app_2_5.xsd\" id=\"WebApp_ID\" version=\"2.5\">\n" +
		"  <display-name>TestEmbedd</display-name>\n";

	private final static String SERVLET_HEAD = 
		"  <servlet id=\"bridge\">\n" +
		"		<servlet-name>equinoxbridgeservlet</servlet-name>\n" +
		"		<servlet-class>org.eclipse.equinox.servletbridge.SpagicServlet</servlet-class>\n" +
		"		<init-param>\n" +
		"			<param-name>commandline</param-name>\n" +
		"			<param-value>-console</param-value>			\n" +
		"		</init-param>		\n" +
		"		<init-param>\n" +
		"			<param-name>enableFrameworkControls</param-name>\n" +
		"			<param-value>true</param-value>			\n" +
		"		</init-param>\n" +
		"		<init-param>\n" +
		"			<param-name>extendedFrameworkExports</param-name>\n" +
		"			<param-value>org.spagic3.client.api</param-value>			\n" +
		"		</init-param>\n" +
		"\n" +
		"		<init-param>\n" +
		"			<param-name>spagic.home</param-name>\n" +
		"			<param-value>";

	private final static String SERVLET_TAIL = 
		"</param-value>			\n" +
		"		</init-param>\n" +
		"		<init-param>\n" +
		"			<param-name>frameworkLauncherClass</param-name>\n" +
		"			<param-value>org.eclipse.equinox.servletbridge.FrameworkLauncher</param-value>\n" +
		"		</init-param>	\n" +
		"		<load-on-startup>1</load-on-startup>\n" +
		"	</servlet>\n";

	private final static String FILE_TAIL = 	
		"  <welcome-file-list>\n" +
		"    <welcome-file>index.html</welcome-file>\n" +
		"    <welcome-file>index.htm</welcome-file>\n" +
		"    <welcome-file>index.jsp</welcome-file>\n" +
		"    <welcome-file>default.html</welcome-file>\n" +
		"    <welcome-file>default.htm</welcome-file>\n" +
		"    <welcome-file>default.jsp</welcome-file>\n" +
		"  </welcome-file-list>\n" +
		"</web-app>\n";


	public static String servlet(String deployPath) {
		StringBuilder file = new StringBuilder(SERVLET_HEAD);
		file.append(deployPath);
		file.append(SERVLET_TAIL);
		return file.toString();
	}
	
	public static void printWholeFile(PrintWriter prw, String deployPath) {
		prw.print(FILE_HEAD);
		prw.print(SERVLET_HEAD);
		prw.print(deployPath);
		prw.print(SERVLET_TAIL);
		prw.print(FILE_TAIL);
	}


}
