/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.ui.metadataeditor;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IStorage;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IFileEditorInput;
import org.eclipse.ui.IPersistableElement;
import org.spagic3.ui.metadataeditor.model.IModel;

public class MetadataEditorInput implements IEditorInput {


	private IModel model;
	private IFileEditorInput fileEditorInput;
		
	public MetadataEditorInput(IFileEditorInput fileEditorInput) {
		this.fileEditorInput = fileEditorInput;
	}

//	public boolean equals(Object obj) {
//		if (obj instanceof MetadataEditorInput) {
//			final MetadataEditorInput other = (MetadataEditorInput) obj;
//			return fileEditorInput.equals(other);
//		}
//		return false;
//	}

	public IModel getModel() {
		return model;
	}

	public void setModel(IModel model) {
		this.model = model;
	}

	public IFileEditorInput getFileEditorInput() {
		return fileEditorInput;
	}

	public String getName() {
		return fileEditorInput.getName();
	}

	public boolean exists() {
		return fileEditorInput.exists();
	}

	public Object getAdapter(Class arg0) {
		return fileEditorInput.getAdapter(arg0);
	}

	public IFile getFile() {
		return fileEditorInput.getFile();
	}

	public ImageDescriptor getImageDescriptor() {
		return fileEditorInput.getImageDescriptor();
	}

	public IPersistableElement getPersistable() {
		return fileEditorInput.getPersistable();
	}

	public IStorage getStorage() throws CoreException {
		return fileEditorInput.getStorage();
	}

	public String getToolTipText() {
		return fileEditorInput.getToolTipText();
	}

}