/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.ui.metadataeditor.model;

import java.util.ArrayList;
import java.util.List;
import java.util.Collections;;

public class MetadataDefinition implements IModelPart {
	 	
private String Id = "";
	private List<IModelPart> parts = new ArrayList<IModelPart>();
	private IModel model;
	private IModelPart parent;

	public String getId() {
		return Id;
	}

	public void setId(String id) {
		Id = id;
	}

	public boolean addPart(IModelPart e) {
		e.setModel(model);
		e.setParent(this);
		return parts.add(e);
	}

	public boolean removePart(IModelPart o) {
		o.setModel(null);
		o.setParent(null);
		return parts.remove(o);
	}

	public IModelPart[] getParts() {
		return parts.toArray(new IModelPart[0]);
	}

	public IModel getModel() {
		return model;
	}

	public void setModel(IModel model) {
		this.model = model;
	}

	public IModelPart getParent() {
		return parent;
	}

	public void setParent(IModelPart parent) {
		this.parent = parent;
	}
	
	
	public int findIndex(IModelPart p) throws Exception {
		
		int index = 0;
		boolean foundPart = false;
		//for(int i=0; i<parts.size(); i++){
		while(!foundPart && index < parts.size()){
		IModelPart modelPart = (IModelPart) parts.get(index);
			if( modelPart.equals(p) ){
				foundPart = true;
			}
		index ++;
		}
		if(foundPart == false){
			throw new Exception("Item not found");
		}
		
		index--;
		return index;
		
	}
	
	public void movePartUp (IModelPart p) {
		try {
			int	toMoveUp = findIndex(p);
			if(toMoveUp > 0)
				Collections.swap(parts, toMoveUp-1, toMoveUp);
		} catch (Exception e) {
			e.printStackTrace();
		}			
	}
	
	public void movePartDown (IModelPart p) {
		try {
			int	toMoveDown= findIndex(p);
			if(toMoveDown < (parts.size())-1)
			Collections.swap(parts, toMoveDown, toMoveDown+1);
		} catch (Exception e) {
			e.printStackTrace();
		}			
	}

	

}
