/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.ui.perspective;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

public class SpagicPerspectiveFactory implements IPerspectiveFactory {

	public void createInitialLayout(IPageLayout layout) {
		String editorArea = layout.getEditorArea();
		
		layout.addView(IPageLayout.ID_PROJECT_EXPLORER, 
				IPageLayout.LEFT, 0.25f, editorArea);
		
		IFolderLayout bottom = layout.createFolder("bottom", 
				IPageLayout.BOTTOM, 0.66f, editorArea);
		bottom.addView(IPageLayout.ID_PROP_SHEET);
		bottom.addView("org.eclipse.stp.im.tool.in.bpmneditor.view.ImView");
		bottom.addView("org.spagic.ui.view.ObservableAttributeView");
		
		layout.addActionSet("org.eclipse.stp.im.resource.actionSet");
		layout.addActionSet("org.spagic.ui.actionSet");
		layout.addActionSet("org.spagic3.ui.deploymentservice.actionSet");
	}

}
