/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.ui.resources;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.stp.im.resources.IImResource;
import org.eclipse.stp.im.resources.IImResourceImporter;
import org.spagic3.utils.SpagicUtilsActivator;
import org.spagic3.utils.preference.SpagicPreferenceConstants;

public class Spagic3ResourceImporter extends Spagic3ResourceManager implements IImResourceImporter {

	public Spagic3ResourceImporter(){
		initNamespaces();
	}
	
	public List<IImResource> importResources(String resourceType) {
		if (resourceType.equalsIgnoreCase(IImResource.DATA_SOURCE_IM_RESOURCE_TYPE))
			return importDataSources();
		else
			return new ArrayList<IImResource>();
	}
	
	
	public List<IImResource> importDataSources(){
		String response = invoke("<REQUESTED_RESOURCES><ITEM id='DATASOURCES'/></REQUESTED_RESOURCES>");
		return getDatasourceListFromResponse(response);
	}

	

	@Override
	protected String getURL() {
		String strURL = SpagicUtilsActivator.getDefault().getPluginPreferences().getString(SpagicPreferenceConstants.P_SERVICE_MANAGER_RESOURCE_GET_SERVICE_URL);
		return strURL;

	}
	
	
	
	
	
	
}
