/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.ui.serviceeditor.model;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import javax.xml.parsers.ParserConfigurationException;

import org.spagic3.core.servicedefinitions.extensionprovider.AbstractServiceDefinition;
import org.spagic3.service.model.IComboProvider;
import org.xml.sax.SAXException;

public class BaseComboProviderFactoryContributor extends AbstractServiceDefinition {

	public BaseComboProviderFactoryContributor() throws IOException, ParserConfigurationException, SAXException {
		Map<String, IComboProvider> comboProviderFactoryontribution
			= new HashMap<String, IComboProvider>();
		comboProviderFactoryontribution.put("StaticComboProvider", new StaticComboProvider());
		comboProviderFactoryontribution.put("DataSourcesComboProvider", new DataSourcesComboProvider());
		setComboProviderFactoryContribution(comboProviderFactoryontribution);
	}
	
}
