/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.ui.serviceeditor.model;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.stp.im.resources.IImResource;
import org.eclipse.stp.im.resources.ImResourcesActivator;
import org.eclipse.stp.im.resources.datasources.DataSourceImResource;
import org.spagic3.service.model.IComboProvider;

public class DataSourcesComboProvider implements IComboProvider {

	public DataSourcesComboProvider() {}
	
	public List<String> getComboItems() {
		List<IImResource> resourcesList =  ImResourcesActivator.getImResourcesWithType(DataSourceImResource.DATA_SOURCE_IM_RESOURCE_TYPE);
		List<String> values = new ArrayList<String>();
		for (IImResource resource : resourcesList){
			values.add(resource.getId());
		}
		return values;
	}

}
