/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.ui.serviceeditor.model;

import java.util.Map;
import java.util.Properties;

public interface IServiceModel {
	

	public String getSpagicId();
	public void setSpagicId(String spagicId);
	public String getFactoryName();
	public void setFactoryName(String factoryName);

	public Properties getProperties();
	public Map<String, Map<String, Properties>> getMapProperties();
	
	public String get(String propertyName);
	
	// Simple Properties Management
	public void addProperty(String propertyName, String propertyValue);
	public void removeProperty(String propertyName);
	
	
	public void addPropertyMap(String mapPropertyName);
	public void removePropertyMap(String mapPropertyName);

	public void addEntryToPropertyMap(String mapPropertyName, String key, Properties prop);
	public void removeEntryFromPropertyMap(String mapPropertyName, String key);
	public Properties getEntryForPropertyMap(String mapPropertyName, String key);
	
}
