/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.ui.serviceeditor.model;

import java.util.Properties;

public class MapPropertyModifier implements IPropertyModifier {

	private IServiceModel model;
	private String mapName;
	private String key;
	private String name;
	
	public MapPropertyModifier(IServiceModel model, String mapName, String key, String name) {
		this.model = model;
		this.mapName = mapName;
		this.key = key;
		this.name = name;
	}
	
	public String getValue() {
		return model == null ? null : (String) model.getEntryForPropertyMap(mapName, key).get(name);
	}
	
	/* (non-Javadoc)
	 * @see org.spagic3.ui.serviceeditor.model.IPropertyModifier#setValue(java.lang.String)
	 */
	public void setValue(String value) {
		if (model != null) {
			Properties toUpdate = model.getEntryForPropertyMap(mapName, key);
			if (toUpdate != null) {
				toUpdate.put(name, value);
			}
		}
	}

	public IServiceModel getModel() {
		return model;
	}

	public void setModel(IServiceModel model) {
		this.model = model;
	}

	public String getMapName() {
		return mapName;
	}

	public void setMapName(String mapName) {
		this.mapName = mapName;
	}

	public String getKey() {
		return key;
	}

	public void setKey(String key) {
		this.key = key;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getId() {
		return mapName + ":" + key + ":" + name;
	}
	
}
