/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.ui.serviceeditor.model;

import java.util.ArrayList;
import java.util.List;

import org.spagic3.service.model.IConfigurableComboProvider;
import org.spagic3.ui.serviceeditor.model.ServiceModelHelper;
import org.w3c.dom.Node;

public class StaticComboProvider implements IConfigurableComboProvider {

	private List<Node> config;

	public StaticComboProvider() {}

	public void setConfig(List<Node> config) {
		this.config = config;
	}

	public List<String> getComboItems() {
		List<String> values = new ArrayList<String>();
		for (Node configNode : config) {
			final String comboValues = ServiceModelHelper.evalXPathAsString(
					configNode, "combo-provider-parameter[@name=\"comboValues\"]/@value");
			for (String value : comboValues.split(";")) {
				values.add(value.trim());
			}
		}
		return values;
	}

}
