/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.ui.dnd;

import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.stp.bpmn.dnd.IDnDHandler;

public class ServiceFileDndFactory implements IAdapterFactory {
	 

		@SuppressWarnings("unchecked")
		public Object getAdapter(Object adaptableObject, Class adapterType) {
			if (adapterType.equals(IDnDHandler.class)) {
				if (adaptableObject instanceof IResource) {
					IResource f = (IResource) adaptableObject;
					String extension = f.getFileExtension();
					if (extension.equalsIgnoreCase("service") || 
						extension.equalsIgnoreCase("connector") || 
						extension.equals("scrappy")){
						return new ServiceFileDndHandler(f);
					}else{
						return null;
					}
					
				}
			}
			return null;
		}

		
		/**
	     * Returns the collection of adapter types handled by this
	     * factory.
	     * <p>
	     * This method is generally used by an adapter manager
	     * to discover which adapter types are supported, in advance
	     * of dispatching any actual <code>getAdapter</code> requests.
	     * </p>
	     *
	     * @return the collection of adapter types
	     */
		@SuppressWarnings("unchecked")
		public Class[] getAdapterList() {
			return new Class[] {IDnDHandler.class};
		}


}
